//	TorusGames-OpenGL.h
//
//	© 2010 by Jeff Weeks
//	See TermsOfUse.txt

#pragma once


//	Comment or uncomment the following lines to support
//	OpenGL ES 1 and/or OpenGL ES 2.  Someday, when OpenGL ES 1
//	is obsolete, the code to support it may be removed.
//	However, as of February 2010, Apple still sells iPhones and iPod Touches
//	with no OpenGL ES 2 support (i.e. no programmable vertex shaders),
//	so I should maintain OpenGL ES 1 support for at least several more years.
//
//	We can also hope that someday all Mac OS and iPhone OS devices
//	will run off a common OpenGL 3.2 core profile, but I have no idea
//	whether Apple shares this hope or not.
//
//	During development, be sure to test this code with all four 
//	logical combinations:  nothing, GLES1 only, GLES2 only and both.
//	The "nothing" setting won't display anything, of course, but
//	it should compile cleanly fail gracefully at run time.
//	The point of testing with GLES1 only or GLES2 only is
//	to smoke out any compile-time errors.  The shipping app should
//	of course enable both GLES1 and GLES2.
#ifdef TORUS_GAMES_FOR_OPENGL_ES
#define SUPPORT_OPENGL_ES_1
#define SUPPORT_OPENGL_ES_2	//	OPENGL ES 2 WORKS FINE IN SIMULATOR.
							//	TEST ON REAL DEVICE BEFORE RELEASING FOR PUBLIC USE.
#endif


//	Include appropriate OpenGL header files.
#ifdef __APPLE__					//	Apple

#ifdef TORUS_GAMES_FOR_OPENGL_ES	//	Apple - iPhone OS

#ifdef SUPPORT_OPENGL_ES_1			//	Apple - iPhone OS - OpenGL 1
#import <OpenGLES/ES1/gl.h>
#import <OpenGLES/ES1/glext.h>
#endif

#ifdef SUPPORT_OPENGL_ES_2			//	Apple - iPhone OS - OpenGL 2
#import <OpenGLES/ES2/gl.h>
#import <OpenGLES/ES2/glext.h>
#endif

#else								//	Apple - Mac OS

#include <OpenGL/gl.h>

#endif	//	TORUS_GAMES_FOR_OPENGL_ES

#endif	//	__APPLE__


#ifdef __WIN32__					//	Windows
#include "GeometryGames-Win32-OpenGLEntryPoints.h"
#endif	//	__WIN32__
