// 	TorusGamesEAGLView.h
//
//	© 2010 by Jeff Weeks
//	See TermsOfUse.txt

#import <UIKit/UIKit.h>


@class	EAGLContext,
		TorusGamesMainViewController,
		TorusGamesModelData;


@interface TorusGamesEAGLView : UIView
{
	IBOutlet TorusGamesMainViewController	*itsTorusGamesMainViewController;
	
	//	EAGL context
	EAGLContext	*itsContext;

	//	Backbuffer's pixel dimensions
	signed int		itsBackingWidth,
					itsBackingHeight;
	
	//	OpenGL names for the frame buffer and color buffer and used to render to this view
	unsigned int	itsFramebuffer,
					itsColorRenderbuffer;
	
	//	OpenGL name for the depth buffer that is attached to itsFramebuffer,
	//	or 0 if no depth buffer is present.
	unsigned int	itsDepthRenderbuffer;

	//	Store the time of the previous touch motion,
	//	so we can later compute a velocity.
	double		itsLastTouchTime;
}

+ (Class)layerClass;
- (id)initWithCoder:(NSCoder*)coder;
- (EAGLContext *)context;

- (void)layoutSubviews;
- (BOOL)createFramebuffer;
- (void)destroyFramebuffer;

- (void)drawViewUsing:(TorusGamesModelData *)someModelData;

- (void)touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event;
- (void)touchesMoved:(NSSet *)touches withEvent:(UIEvent *)event;
- (void)touchesEnded:(NSSet *)touches withEvent:(UIEvent *)event;
- (void)touchesCancelled:(NSSet *)touches withEvent:(UIEvent *)event;
- (CGPoint)touchLocation:(UITouch *)aTouch;
- (CGPoint)touchMotion:(UITouch *)aTouch;

@end
