// 	TorusGamesGameChoiceController.m
//
//	© 2010 by Jeff Weeks
//	See TermsOfUse.txt

#import "TorusGamesGameChoiceController.h"
#import "TorusGamesPodOSUtilities.h"

struct
{
	GameType	itsGame;
	char		*itsName;
	NSString	*itsImageName;
} gGameNames[] =
{
	{GameTicTacToe,		"Tic-Tac-Toe",		@"Table Images/Game-TicTacToe.tiff"	},
	{GameMaze,			"Maze",				@"Table Images/Game-Maze.tiff"		},
	{GameCrossword,		"Crossword",		@"Table Images/Game-Crossword.tiff"	},
	{GameWordSearch,	"Word Search",		@"Table Images/Game-WordSearch.tiff"},
	{GameJigsaw,		"Jigsaw Puzzle",	@"Table Images/Game-Jigsaw.tiff"	},
	{GameChess,			"Chess",			@"Table Images/Game-Chess.tiff"		},
	{GamePool,			"Pool",				@"Table Images/Game-Pool.tiff"		}
};


@implementation TorusGamesGameChoiceController

- (id)initWithParent:(TorusGamesTabBarController *)aParent gameChoice:(GameType *)aGameChoice
{
	if ((self = [super initWithTag:TabPageGameChoice parent:aParent]) != nil)
	{
		itsGameChoice = aGameChoice;
	}
	return self;
}

- (NSInteger)numberOfSectionsInTableView:(UITableView *)aTableView
{
	return 1;
}

- (NSString *)tableView:(UITableView *)aTableView titleForHeaderInSection:(NSInteger)aSection
{
	return GetLocalizedTextAsNSString("Game");	//	alternative:  "Choose a Game" (translations are archived)
}

- (NSInteger)tableView:(UITableView *)aTableView numberOfRowsInSection:(NSInteger)aSection
{
	return BUFFER_LENGTH(gGameNames);
}

- (UITableViewCell *)tableView:(UITableView *)aTableView cellForRowAtIndexPath:(NSIndexPath *)anIndexPath
{
	UITableViewCell	*theCell;
	UILabel			*theLabel;
	unsigned int	theRow;
	NSString		*theTitle;
	bool			theCheckmark;

	theCell			= [[[UITableViewCell alloc] initWithFrame:CGRectZero reuseIdentifier:nil] autorelease];
	theLabel		= [theCell textLabel];
	theRow			= [anIndexPath row];
	theTitle		= GetLocalizedTextAsNSString(gGameNames[theRow].itsName);
	theCheckmark	= (gGameNames[theRow].itsGame == *itsGameChoice);

	[theLabel setText:theTitle];
	[theCell setAccessoryType:(theCheckmark ? UITableViewCellAccessoryCheckmark : UITableViewCellAccessoryNone)];
	[[theCell imageView] setImage:[UIImage imageNamed:gGameNames[theRow].itsImageName]];

	return theCell;
}

- (NSIndexPath *)tableView:(UITableView *)aTableView willSelectRowAtIndexPath:(NSIndexPath *)anIndexPath
{
	unsigned int	theRow;

	theRow = [anIndexPath row];

	*itsGameChoice = gGameNames[theRow].itsGame;

	[self buttonWasPressed];

	return nil;
}

@end
