// 	TorusGamesTabBarController.h
//
//	© 2010 by Jeff Weeks
//	See TermsOfUse.txt

#import <UIKit/UIKit.h>
#import "TorusGamesTabPageController.h"
#import "TorusGames-Common.h"


typedef struct
{
	GameType		itsGame;
	TopologyType	itsTopology;
	bool			itsHumanVsComputer;
	char			itsLanguageCode[3];	//	two ASCII letters with terminating zero
} TorusGamesSettings;


@protocol TorusGamesTabBarControllerParent;

@interface TorusGamesTabBarController : UITabBarController
{
	id <TorusGamesTabBarControllerParent>	itsParent;
	TorusGamesSettings						itsSettings;
}

- (id)initWithParent:(id <TorusGamesTabBarControllerParent>)aParent
		settings:(TorusGamesSettings)someInitialSettings
		tab:(TabPageTag)anInitialTab;

- (void)buttonWasPressedInPage:(TabPageTag)aTabPageTag;

@end

@protocol TorusGamesTabBarControllerParent
- (void)tabBarControllerDidFinishWithSettings:(TorusGamesSettings)someNewSettings tab:(TabPageTag)aLastTab;
@end
