// 	TorusGamesTabPageController.h
//
//	© 2010 by Jeff Weeks
//	See TermsOfUse.txt

#import <UIKit/UIKit.h>


//	The TabPageTag is used for two purposes:
//
//	1.	to recognize which TorusGamesTabPageController
//		is reporting a button press to the TorusGamesTabBarController, and
//
//	2.	as an index into theTabBarTitleKeys[] in refreshTabBarItem.
//
//	For the second purpose, it's essential that the values begin
//	at 0 and run sequentially, and that the order not be changed
//	with adjusting theTabBarTitleKeys[] accordingly.
typedef enum
{
	TabPageGameChoice = 0,
	TabPageOptions,
	TabPageLanguage,
	TabPageHelp,
	NumTabPageTags
} TabPageTag;


@class TorusGamesTabBarController;


@interface TorusGamesTabPageController : UITableViewController
{
	TabPageTag					itsTabPageTag;
	TorusGamesTabBarController	*itsParent;
}

- (id)initWithTag:(TabPageTag)aTabPageTag parent:(TorusGamesTabBarController *)aParent;

- (void)refreshLanguage;
- (void)refreshTabBarItem;
- (void)buttonWasPressed;

@end
